	.section ".init"
	.global _start
	.arm
@---------------------------------------------------------------------------------
_start:
@---------------------------------------------------------------------------------
	mov	r0, #0x04000000		@ IME = 0;
	add	r0, r0, #0x208
	strh	r0, [r0]

	ldr r1,=0x00002078		@disable DTCM and protection unit
	mcr p15,0,r1,c1,c0
	ldr r0,=0x0080000A
	mcr p15,0,r0,c9,c1		@TCM base = 0x00800*4096, size = 16 KB
	mrc p15,0,r0,c1,c0		@throw-away read of cp15.c1
	orr r1,r1,#0x10000
	mcr p15,0,r1,c1,c0		@cp15.c1 = 0x00012078;

	msr	cpsr_c,#0x12
	ldr	sp, =__sp_irq		@ Set IRQ stack
	msr	cpsr_c,#0x13
	ldr	sp, =__sp_svc		@ Set SVC stack
	msr	cpsr_c,#0x1f
	ldr	sp, =__sp_usr		@ Set user stack

	ldr	r0, =__itcm_lma		@ Copy ITCM
	ldr	r1, =__itcm_start
	ldr	r2, =__itcm_end
	bl	CopyMem

	ldr	r0, =__dtcm_lma		@ Copy DTCM
	ldr	r1, =__dtcm_start
	ldr	r2, =__dtcm_end
	bl	CopyMem

	ldr	r0, =__bss_start	@ Clear BSS
	ldr	r1, =__bss_end
	bl	ClearMem

	ldr	r0, =__sbss_start	@ Clear SBSS
	ldr	r1, =__sbss_end
	bl	ClearMem

	ldr	r1, =fake_heap_end	@ set heap end
	ldr	r0, =__eheap_end
	str	r0, [r1]
	
	@ldr r3, =_init			@ global constructors
	@bl	_call_via_r3

	ldr pc,=main
@---------------------------------------------------------------------------------
ClearMem:
@  r0 = Start Address
@  r1 = End address
@---------------------------------------------------------------------------------
	mov r2,#0
clr0:
	cmp r0,r1
	strlo r2,[r0],#4
	blo clr0
	bx lr
@---------------------------------------------------------------------------------
CopyMem:
@  r0 = Source Address
@  r1 = Dest start
@  r2 = Dest end
@---------------------------------------------------------------------------------
copy0:
	cmp r1,r2
	ldrlo r3,[r0],#4
	strlo r3,[r1],#4
	blo copy0
	bx lr
@---------------------------------------------------------------------------------
