#include <nds.h>
#include "fw.h"

static void hex32(int row,int d,int hi) {
	u16 *p;
	u16 c;
	int i;
	
	p=(u16*)(SCREEN_BASE_BLOCK(0)+row*64);
	for(i=7;i>=0;i--) {
		c=d&0x0f;
		if(c<10) c+='0';
		else c=c-10+'A';
		if(!hi) c|=0x1000;
		d>>=4;
		p[i]=c;
		hi--;
	}
}

static void dumpmem(u8 *addr) {
	u16 *p;
	u16 c;
	int i,j;
	u32 d;
	int hi=0;
	
	p=(u16*)(SCREEN_BASE_BLOCK(0)+64);
	for(j=0;j<23*16;j++) {
		d=addr[j];
		if(!(j&15)) hi++;
		for(i=1;i>=0;i--) {
			c=d&0x0f;
			if(c<10) c+='0';
			else c=c-10+'A';
			if(hi&1) c|=0x1000;
			d>>=4;
			p[i]=c;
		}
		p++;
		p++;
		hi++;
	}
}

void memdump() {
	int k;
	int sel=0;
	int addr=0x2400000;
			
	k=KEY_UP;	//force a screen refresh
	while(1) {
		swiWaitForVBlank();
		if(k) {
			switch(k) {
				case KEY_A:
					addr+=1<<((sel&7)*4);
					break;
				case KEY_B:
					addr-=1<<((sel&7)*4);
					break;
				case KEY_LEFT:
					sel++;
					if(sel>=8) sel--;
					break;
				case KEY_RIGHT:
					sel--;
					if(sel<0) sel=0;
					break;
			}
			hex32(0,addr,sel);
			dumpmem((u8*)addr);
		}
		k=keyhit();
	}
}
