	.arm
	.global _start
_start:
	adr r0,go_thumb+1
	bx r0
@-------------------
	.thumb
go_thumb:
	mov r0,#8			@do some reads to wake up the cart
	lsl r0,#24
	ldr r2,GBAentry
GBAread:
	ldmia r0!,{r1}
	cmp r0,r2
	bne GBAread

	ldr r0,=0x04000130	@A+B+SEL+START?
	ldrh r0,[r0]
	lsl r0,#28
	beq failsafe
@---------------------
load_NDS:
	ldr r0,=0x10000
	mov r11,r0
	adr r1,header
	mov r2,#0x40
	bl read_firmware	@load header

	adr r7,header+0x20
	ldmia r7!,{r0,r4}
	ldmia r7!,{r1,r2}
	add r0,r11
	bl read_firmware	@load arm9 code

	ldmia r7!,{r0,r5}
	ldmia r7!,{r1,r2}
	add r0,r11
	bl read_firmware	@load arm7 code
	
	ldr r7,arm9loopaddr
	str r4,[r7]			@run arm9
	bx r5				@run arm7
@-------------------------
failsafe:				@last-ditch recovery attempt
	mov r1,#0
	mov r2,#1
	bl writeSPI
	mov r1,#0x3d
	mov r2,#0			@enable backlights+sound so failsafe isn't running blind
	bl writeSPI			@blink LED to show the world we're not dead

	adr r7,passme_stub
	ldmia r7!,{r0-r4}
	stmia r2!,{r0-r1}	@write passme stub
	str r0,[r3]			@run arm9 (wait in passme loop)
	bx r4				@run arm7 (jump to GBA cart)
@-------------------------
writeSPI:
	ldr r3,=0x2369
	mov r0,#0
	bx r3
@--------------------------
read_firmware:			@(src,dst,size)
	ldr r3,=0x2437
	bx r3
@--------------------------
	.ltorg
	.arm
passme_stub:
	.word 0x23ffe28		@r0
	ldr pc,passme_stub	@r1
	.word 0x23ffe24		@r2
arm9loopaddr:
	.word 0x23a0004		@r3
GBAentry:
	.word 0x80000c0		@r4
header:
